package org.openjdk.gcbench.tenure;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.TimeUnit;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(jvmArgsPrepend = {"--add-exports", "java.base/jdk.internal.misc=ALL-UNNAMED"})
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(Threads.MAX)
@State(Scope.Benchmark)
public class Queues {

    ConcurrentLinkedQueue<Object> tenures;

    @Param({"100000"})
    int size;

    @Setup
    public void setup() {
        tenures = new ConcurrentLinkedQueue<>();
        for (int c = 0; c < size; c++) {
            tenures.add(new byte[64]);
        }
    }

    @Benchmark
    public Object test() {
        tenures.add(new byte[64]);
        return tenures.poll();
    }

}
